Package: dragulaR
Type: Package
Title: Drag and Drop Elements in 'Shiny' using 'Dragula Javascript
        Library'
Version: 0.3.1
Authors@R: c(person("Nicolas", "Bevacqua", role = c("aut", "cph"),
       comment = "dragula library in htmlwidgets/lib, https://github.com/bevacqua/dragula"),
       person("Zygmunt", "Zawadzki", role = c("aut", "cre"),
       comment = "R interface", email = "zygmunt@zstat.pl"))
Maintainer: Zygmunt Zawadzki <zygmunt@zstat.pl>
Description: Move elements between containers in 'Shiny' without explicitly using 'JavaScript'. It can be used to build custom inputs or to change the positions of user interface elements like plots or tables.
License: GPL-2
LazyData: TRUE
Depends: htmlwidgets, shiny
Imports: shinyjs
RoxygenNote: 6.0.1
Suggests: covr, testthat
BugReports: https://github.com/zzawadz/dragulaR/issues
URL: https://dragular.zstat.pl/
NeedsCompilation: no
Packaged: 2018-06-15 18:16:18 UTC; zzawadz
Author: Nicolas Bevacqua [aut, cph] (dragula library in htmlwidgets/lib,
    https://github.com/bevacqua/dragula),
  Zygmunt Zawadzki [aut, cre] (R interface)
Repository: CRAN
Date/Publication: 2018-06-17 14:08:01 UTC
Built: R 4.6.0; ; 2026-04-26 17:43:31 UTC; unix

library(shiny)

makeElement <- function(data, name)
{
  div(style = "border-width:2px;border-style:solid;",
    drag = name,
    div(class = "active title", name),
    div(class = "active content", p(sprintf("Class: %s", class(data[[name]])))))
}

ui <- fluidPage(
  titlePanel("Drag and drop elements with dragulaR"),

  fluidRow(style = "margin: 15px;",
    column(3,
      h3("Drag from here:"),
      div(id = "Available", style = "min-height: 600px;",
        lapply(colnames(mtcars), makeElement, data = mtcars))
    ),
    column(3,
      h3("Drop here:"),
      div(id = "Model", style = "min-height: 600px;")
    ),
    column(6,
      plotOutput("plot"),
      verbatimTextOutput("print")
    )
  ),
  dragulaOutput("dragula")

)

server <- function(input, output) {

  output$dragula <- renderDragula({
    dragula(c("Available", "Model"))
  })

  output$plot <- renderPlot({
    req(input$dragula)
    state <- dragulaValue(input$dragula)
    validate(need(length(state$Model) > 1, message = "Please select at least two variables."))

    plot(mtcars[,state$Model])
  })

  output$print <- renderText({
    state <- dragulaValue(input$dragula)
    sprintf("Available:\n  %s\n\nModel:\n  %s",
            paste(state$Available, collapse = ", "),
            paste(state$Model, collapse = ", "))

  })

}

shinyApp(ui = ui, server = server)

library(shiny)
library(dragulaR)
library(shinyjs)

ui <- fluidPage(
        useShinyjs(),
        useDragulajs(),
        titlePanel("Add new elements to container elements"),
        verbatimTextOutput("order"),
        actionButton("Add", label = "Add"),
        fluidRow(id = "elements",
                 div(id = "placeholder")),
        dragula("elements", id = "dragula")
)

server <- function(input, output) {

  output$order <- renderPrint({
    dragulaValue(input$dragula)
  })
  counter <- reactiveVal(0)

  observeEvent(input$Add, {
    id <- counter()
    element <- div(drag = id, tags$h3(paste("Element", id)))
    insertUI(selector = "#placeholder", where = "beforeBegin", ui = element, immediate = TRUE)
    counter(id + 1)
    js$refreshDragulaR("dragula")

  })

}

shinyApp(ui = ui, server = server)

library(shiny)
library(dragulaR)

fooUI <- function(id) {
  ns <- NS(id)
  tagList(
    verbatimTextOutput(ns("order")),
    fluidRow(id = ns("plots"),
             column(6, plotOutput(ns("iris")), drag = "iris"),
             column(6, plotOutput(ns("mtcars")), drag = "mtcars"),
             column(6, plotOutput(ns("AirPassengers")), drag = "AirPassengers"),
             column(6, plotOutput(ns("Formaldehyde")), drag = "Formaldehyde")),
    dragula(ns("plots"), id = ns("dragula"))
  )
}

fooServer <- function(input, output, session) {
  output$order <- renderPrint({
    dragulaValue(input$dragula)
  })

  output$iris = renderPlot({plot(iris)})
  output$mtcars = renderPlot({plot(mtcars)})
  output$AirPassengers = renderPlot({plot(AirPassengers)})
  output$Formaldehyde = renderPlot({plot(Formaldehyde)})
}

ui <- fluidPage(
        titlePanel("Drag and drop elements with dragulaR - inside module"),
        fooUI("foo")
)

server <- function(input, output) {

  callModule(module = fooServer, id = "foo")

}

shinyApp(ui = ui, server = server)

library(shiny)
library(dragulaR)

ui <- fluidPage(
        titlePanel("Get order of elements in div"),
        verbatimTextOutput("order"),
        fluidRow(id = "plots",
                 column(6, plotOutput("iris"), drag = "iris"),
                 column(6, plotOutput("mtcars"), drag = "mtcars"),
                 column(6, plotOutput("AirPassengers"), drag = "AirPassengers"),
                 column(6, plotOutput("Formaldehyde"), drag = "Formaldehyde")),
        dragula("plots", id = "dragula")
)

server <- function(input, output) {


  output$order <- renderPrint({
    dragulaValue(input$dragula)
  })

  output$iris = renderPlot({plot(iris)})
  output$mtcars = renderPlot({plot(mtcars)})
  output$AirPassengers = renderPlot({plot(AirPassengers)})
  output$Formaldehyde = renderPlot({plot(Formaldehyde)})

}

shinyApp(ui = ui, server = server)

library(shinydashboard)
library(dragulaR)

ui <- dashboardPage(
  dashboardHeader(),
  dashboardSidebar(),
  dashboardBody(
    box(width = 12, verbatimTextOutput("text")),
    box(width = 6, id = "drag1", title = "Drag1",
      div(drag = "iris", box(width = 12,  plotOutput("iris"))),
      div(drag = "mtcars", box(width = 12, plotOutput("mtcars"))),
      div(drag = "AirPassengers", box(width = 12, plotOutput("AirPassengers"))),
      div(drag = "Formaldehyde", box(width = 12, plotOutput("Formaldehyde")))
    ),
    box(width = 6, id = "drag2", title = "Drag2",
        div(drag = "USArrests", box(width = 12, plotOutput("USArrests")))),

    dragulaOutput("Dragula")
  )
)
# Define server logic required to draw a histogram
server <- function(input, output) {

  output$Dragula <- renderDragula({
    dragula(c("drag1", "drag2"))
  })

  output$text <- renderPrint({
    dragulaValue(input$Dragula)
  })

  output$iris = renderPlot({plot(iris)})
  output$mtcars = renderPlot({plot(mtcars)})
  output$AirPassengers = renderPlot({plot(AirPassengers)})
  output$Formaldehyde = renderPlot({plot(Formaldehyde)})
  output$USArrests = renderPlot({plot(USArrests)})
}

# Run the application
shinyApp(ui = ui, server = server)

library(shiny)
library(dragulaR)
library(shinyjs)

datasets <- list(iris = iris, mtcars = mtcars)

help <- "Refreshing dragula after renderUI is a bit problematic.
In the current version, the user needs to perform any action (change the order of values in the dragula's container or move elements around)
to refresh input$dragula state.

You can see this behavior by at the verbatimTextOutput, containing a list with elements names in each dragula container.

It might be not a real problem because there might be other conditions that must be met to proceed.
In this case, the plot disappears because of all columns from elementsOutput must match names from the dataset."

ui <- fluidPage(
  useShinyjs(),
  useDragulajs(),
  titlePanel("Add elements using render ui"),
  selectInput(inputId = "dataset", label = "Select data set:", selected = "iris", choices = c("iris", "mtcars")),
  helpText(help),
  verbatimTextOutput("order"),
  fluidRow(
    column(width = 3, h2("Input"), uiOutput("elementsInput", style = "min-height:200px;background-color:grey;")),
    column(width = 3, h2("Output"), uiOutput("elementsOutput", style = "min-height:200px;background-color:grey;")),
    column(width = 6, plotOutput("plot"))
  ),
  dragula(c("elementsInput", "elementsOutput"), id = "dragula")
)

server <- function(input, output) {

  output$order <- renderPrint({
    req(input$dataset)
    dragulaValue(input$dragula)
  })


  output$elementsInput <- renderUI({

    req(input$dataset)
    lapply(colnames(datasets[[input$dataset]]), function(nm) tags$h3(drag = nm, nm))

  })

  output$elementsOutput <- renderUI({
    # reset elementsOutput after dataset changes
    req(input$dataset)
    div()
  })

  output$plot <- renderPlot({
    req(input$dataset)
    out <- dragulaValue(input$dragula)$elementsOutput
    req(out, all(out %in% colnames(datasets[[input$dataset]])))
    dt <- datasets[[input$dataset]][,out, drop = FALSE]
    plot(dt)
  })


}

shinyApp(ui = ui, server = server)

library(shiny)
library(dragulaR)

ui <- fluidPage(
        titlePanel("Drag and drop elements with dragulaR"),
        fluidRow(id = "plots",
                 column(6, plotOutput("iris")),
                 column(6, plotOutput("mtcars")),
                 column(6, plotOutput("AirPassengers")),
                 column(6, plotOutput("Formaldehyde"))),
        dragula("plots")

)

server <- function(input, output) {

  output$iris = renderPlot({plot(iris)})
  output$mtcars = renderPlot({plot(mtcars)})
  output$AirPassengers = renderPlot({plot(AirPassengers)})
  output$Formaldehyde = renderPlot({plot(Formaldehyde)})

}

shinyApp(ui = ui, server = server)
